#include <stdlib.h>
#include <string.h>

#include <glib.h>
#include <w32lib.h>

DIR *opendir( const char *name ){
	DIR *dir;

	dir = (DIR*)g_malloc( sizeof( DIR ) );
	if ( ! dir ) return NULL;
	memset( dir, 0, sizeof( dir ) );
	dir->dirname = g_strdup( name );
	dir->hFind = 0;

	return dir;
}
int closedir( DIR *dir ){
	FindClose( dir->hFind );
	g_free( dir->dirname );
	g_free( dir );
	return 0;
}
struct dirent *readdir( DIR *dir ){
	WIN32_FIND_DATA fInfo;
	struct dirent *xdirent;
	int ret;

	if ( ! dir->hFind ) {
		gchar *dirname;

		if (dir->dirname)
			dirname = g_strdup_printf( "%s\\*.*", dir->dirname );
		else
			dirname = g_strdup( "\\*.*" );

		dir->hFind = FindFirstFile( dirname, &fInfo );
		g_free( dirname );
		if ( ! dir->hFind )
			ret = 0;
		else
			ret = 1;
	} else {
		ret = (dir->hFind == -1)
			? 0
			: FindNextFile( dir->hFind, &fInfo );
	}
	if ( ! ret ) return NULL;

	xdirent = (struct dirent*)g_malloc( sizeof( struct dirent ) );
	memset( xdirent, 0, sizeof( xdirent ) );

	xdirent->d_ino    = 0;
	xdirent->d_reclen = 0;
	xdirent->d_name   = g_strdup( fInfo.cFileName );
	xdirent->d_namlen = strlen( xdirent->d_name );
	return xdirent;
}
