#include <w32lib.h>
#include <windows.h>

gchar *read_w32_registry_string( char *parent, char *section, char *key ){
	HKEY hKey, rootKey;
	gchar *str;
	int ret;

	char buf[ MAX_PATH ];
	DWORD bufsiz = sizeof( buf );

	if (!parent || !strlen(parent))
		rootKey = HKEY_CURRENT_USER ;
	else if (!strcmp(parent, "HKCR") || !strcmp(parent,"HKEY_CLASSES_ROOT"))
		rootKey = HKEY_CLASSES_ROOT ;
	else if (!strcmp(parent, "HKCU") || !strcmp(parent,"HKEY_CURRENT_USER"))
		rootKey = HKEY_CURRENT_USER ;
	else if (!strcmp(parent, "HKLM") || !strcmp(parent,"HKEY_LOCAL_MACHINE"))
		rootKey = HKEY_LOCAL_MACHINE ;
	else if (!strcmp(parent, "HKU")  || !strcmp(parent,"HKEY_USERS"))
		rootKey = HKEY_USERS ;
	else if (!strcmp(parent, "HKCC") || !strcmp(parent,"HKEY_CURRENT_CONFIG"))
		rootKey = HKEY_CURRENT_CONFIG ;

	str = NULL;
	ret = RegOpenKeyEx( rootKey, section, 0, KEY_READ, &hKey );
	if ( ERROR_SUCCESS == ret ){
		ret = RegQueryValueEx( hKey, key, 0, NULL, 
				(LPBYTE)buf, &bufsiz );
		if ( ERROR_SUCCESS == ret ){
			str = g_strdup( buf );
		}
		RegCloseKey( hKey );
	}
	return str;
}

gchar *get_content_type_from_registry_with_ext( char *ext ){
	HKEY hKey, parent;
	int ret;
	char buf[ MAX_PATH ];
	DWORD bufsiz;
	gchar *section, *key, *value;

	// parent	: HKEY_CLASSES_ROOT
	// section	: ".txt"
	parent = HKEY_CLASSES_ROOT;
	section = g_strconcat( ".", ext, NULL );

	value = NULL;
	while ( 1 ) {
		ret = RegOpenKeyEx( parent, section, 0, KEY_READ, &hKey );
		if ( ERROR_SUCCESS != ret ) {
			// If section is not found...
			value = NULL;
			break;
		}

		// key		: "Content Type"
		key = "Content Type";
		bufsiz = sizeof( buf );
		ret = RegQueryValueEx( hKey, key, 0, NULL, (LPBYTE)buf, &bufsiz );
		if ( ERROR_SUCCESS == ret ) {
			// If value is found!
			RegCloseKey( hKey );
			value = g_strdup( buf );
			break;
		}

		key = "";
		bufsiz = sizeof( buf );
		ret = RegQueryValueEx( hKey, key, 0, NULL, (LPBYTE)buf, &bufsiz );
		if ( ERROR_SUCCESS != ret ) {
			RegCloseKey( hKey );
			value = NULL;
			break;
		}

		RegCloseKey( hKey );
		g_free( section );
		section = g_strdup( buf );
	}

	g_free( section );
	return value;
}
