#include <stdlib.h>
#include <string.h>

#include <w32lib.h>

int strcasecmp( const char *s1, const char *s2 ){
  size_t len1, len2, len;

  len1 = strlen( s1 );
  len2 = strlen( s2 );
  len = ( len1 > len2 )? len1 : len2;

  return strncasecmp( s1, s2, len );
}

int strncasecmp( const char *s1, const char *s2, size_t n ){
  char *t_s1, *t_s2;
  int i, ret;

  t_s1 = calloc( n+1, 1 );
  t_s2 = calloc( n+1, 1 );

  for ( i = 0; i < n && s1[ i ]; i++ )
    t_s1[i] = toupper( s1[i] );
  for ( i = 0; i < n && s2[ i ]; i++ )
    t_s2[i] = toupper( s2[i] );

  ret = strncmp( t_s1, t_s2, n );

  free( t_s1 );
  free( t_s2 );

  return ret;
}

